' This is file h_2_bi_Main.bas
' (C) 2010-2013 by TJF, GPLv3
' It's part of 'h_2_bi.bas' package, see for details:
' http://www.freebasic.net/forum/viewtopic.php?t=15364&postdays=0&postorder=asc&start=0
TYPE H_2_Bi
  DECLARE CONSTRUCTOR
Private:
  AS ErrorHandler PTR Er
  AS CFileReader PTR In
  AS BiWriter PTR Ou
  AS Options PTR Op
  AS Macros PTR Ma
  AS Config PTR Co
  AS STRING Tex, Nam, Typ, NO(4) ', Pr(...) = OUT_TEXT
  AS STRING Pr(OUT_TYPE) = OUT_TEXT
  AS UBYTE Af
  AS INTEGER Kl, ModI, ModO, Ebne, BlNr, BlAZ, BloCom
  AS STRING BlXx, BlRp, BlVo
  AS STRING Einr ', Tabz
  AS STRING IfNa, BlTy

  DECLARE FUNCTION Act(BYREF F AS STRING) AS INTEGER
  DECLARE FUNCTION Line_() AS STRING
  DECLARE FUNCTION PreCo() AS STRING
  DECLARE FUNCTION Block(BYVAL A AS INTEGER = 0) AS STRING

  DECLARE FUNCTION genDefLine() AS STRING
  DECLARE FUNCTION genFieldDim(BYREF Di AS STRING) AS INTEGER
  DECLARE FUNCTION ParaList(BYVAL A AS INTEGER, BYVAL L AS INTEGER) AS STRING
  DECLARE SUB checkNaTy()
  DECLARE SUB checkTy()
  DECLARE SUB translate()

  DECLARE FUNCTION UnsaveDefine() AS INTEGER
  DECLARE FUNCTION checkCast(BYVAL Aa AS INTEGER, BYVAL Ee AS INTEGER, _
                   BYREF Lt AS INTEGER, _
                   Pa() AS STRING) AS INTEGER
  DECLARE FUNCTION genCast(BYREF P AS INTEGER, BYREF Lt AS INTEGER) AS INTEGER
  DECLARE FUNCTION genLogic(BYREF T AS STRING, BYVAL Mo AS INTEGER = 0) AS STRING
  DECLARE FUNCTION genIfComment(BYVAL Mo AS INTEGER = 0) AS STRING
  DECLARE SUB genQuoteNLogic(BYREF T AS STRING, BYVAL Aa AS INTEGER, _
                             BYREF Lt AS INTEGER, BYVAL Mo AS INTEGER = 0)

  DECLARE FUNCTION BlockENUM() AS STRING
  DECLARE FUNCTION BlockTyUn() AS STRING
  DECLARE SUB BlockName(BYVAL Mo AS INTEGER)
  DECLARE SUB read2(BYREF S AS STRING, BYVAL Mo AS INTEGER = 0)
END TYPE

CONSTRUCTOR H_2_Bi
  Op = NEW Options(COMMAND)
  VAR allJobs = ""
  IF Op->RunMod <> 1 THEN '                                no Geany mode
    MSG_WELLCOME
    IF LEN(Op->Msg) THEN ? Op->Msg
    SELECT CASE AS CONST Op->RunMod
    CASE 0
      ? "  Directory: " & CURDIR
      IF LEN(COMMAND) THEN
        ? "   Cmd-line: " & COMMAND;
      ELSE
        ? "  Default configuration (no parameters specified).";
      END IF
    CASE 2 : MSG_VERSION : DELETE Op : EXIT CONSTRUCTOR
    CASE ELSE : MSG_HELP : DELETE Op : EXIT CONSTRUCTOR
    END SELECT
  END IF

  VAR a = 1, e = INSTR(a, Op->Jobs, CHR(1)), e1 = 0
  DO
    VAR n = MID(Op->Jobs, a, e - a)
    IF checkH2Bi(n, Op->RunMod) THEN allJobs &= n & CHR(1)
    a = e + 1 : e = INSTR(a, Op->Jobs, CHR(1))
  LOOP UNTIL e <= 1

  IF Op->RunMod = 1 THEN '                                    Geany mode
    NL = CHR(10)
    Op->O.CD = 1 '                        no extern block, instead CDECL
    Op->O.MF = 0 '                                 mark file start / end
    IF LEN(allJobs) <= 1 THEN allJobs = GEANY_FILE & CHR(1) : CHDIR EXEPATH
  ELSE
    IF LEN(allJobs) <= 1 THEN DELETE Op : EXIT CONSTRUCTOR
  END IF

  DO '                                            all Jobs (.h2bi-files)
    VAR a1 = e1 + 1 : e1 = INSTR(a1, allJobs, CHR(1)) : IF e1 <= a1 THEN EXIT DO
    VAR job = MID(allJobs, a1, e1 - a1)
    In = NEW CFileReader(job & H2BI_FILE_SUFFIX, Op->RunMod)
    IF LEN(In->Erro) THEN
      ?In->Erro
    ELSE
      Er = NEW ErrorHandler(Op->O.ER + 2 * Op->O.ET)
      Co = NEW Config(In, Op) : IF Op->RunMod <> 1 THEN ? NL & Co->Msg;
      Ma = NEW Macros(Co->Macros, Op, Er)
      Op->I.COMM = Op->I.SHCC
      BloCom = Op->FLI AND FLI_MASK_CC
      IF Op->I.BLCO THEN BloCom OR= &b100
      IF Op->Tabs < 0 THEN Pr(0) = !"\t" ELSE Pr(0) = STRING(Op->Tabs, 32)
      IF Op->RunMod = 1 THEN '                                Geany mode
        Ou = NEW BiWriter("", Co, Op, Ma, In, Er)
        IF Ou->Deep = 0 THEN Act("")
        DELETE Ou
      ELSE '                                                   File mode
        VAR a2 = 1, e2 = INSTR(a2, Co->FNams, ";")
        IF Op->O.SI THEN '                          all-in-one file mode
          genTestBas(job, job & ".h;")
          Ou = NEW BiWriter(job, Co, Op, Ma, In, Er)
          IF Ou->Deep = 0 THEN
            WHILE e2 > a2
              IF Act(MID(Co->FNams, a2, e2 - a2)) THEN ? Tex
              a2 = e2 + 1 : e2 = INSTR(a2, Co->FNams, ";")
            WEND
          END IF : DELETE Ou
        ELSE '                                          single file mode
          genTestBas(job, Co->FNams)
          WHILE e2 > a2
            VAR fn = MID(Co->FNams, a2, e2 - a2)
            VAR a1 = INSTRREV(fn, ANY "\/") + 1, e1 = INSTRREV(fn, ".")
            Ou = NEW BiWriter(MID(fn, a1, e1 - a1), Co, Op, Ma, In, Er)
            IF Ou->Deep = 0 THEN IF Act(fn) THEN ? Tex
            DELETE Ou
            a2 = e2 + 1 : e2 = INSTR(a2, Co->FNams, ";")
          WEND
        END IF
      END IF
      DELETE Ma
      DELETE Co
      DELETE Er
    END IF : DELETE In
  LOOP : DELETE Op
END CONSTRUCTOR

' translation
' wertet Eingabe aus (.h oder stdin)
FUNCTION H_2_Bi.Act(BYREF F AS STRING) AS INTEGER
  VAR r = Ou->IncEbne(F) : IF r THEN In = r ELSE Tex = F : RETURN -1
  IF Op->RunMod <> 1 THEN ? "==> "; F
  WHILE In->weGo() : Einr = ""
    read2(!";#{}=")
    SELECT CASE AS CONST In->LaCh()
    CASE 0
      IF LEN(In->Tex) THEN In->Tex = "' " & In->Tex & " ???"
      Ou->add(In->Tex) : EXIT WHILE
    CASE ASC("#") : Ou->add(PreCo())
    CASE ASC("}") : Ou->add(Block())
    CASE ASC("{")
      VAR i = 0 : i = IIF(nextWord(In->Tex, i) = "typedef", i, 0)
      Ou->add(Block(i))
    CASE ASC(";"), ASC("="), ASC(!"\n")
      IF In->LaCh() = ASC("=") THEN
        In->Tex &= "=" : IF In->weGO() THEN read2(";") ' !!! #-PreCo Zeilen
      END IF : IF LEN(In->Tex) THEN Ou->add(Line_())
    CASE ELSE
      Ou->add("' " & In->Tex & " ??? Unknown termination") : EXIT WHILE
    END SELECT : In->newTex()
  WEND
  In = Ou->DecEbne() : RETURN 0
END FUNCTION

' reads to one of the S characters, Mo = 1 : new block
' liest bis zu einem der Zeichen von S, Mo = 1 : neuer Block
SUB H_2_Bi.read2(BYREF S AS STRING, BYVAL Mo AS INTEGER = 0)
  IF Mo THEN In->newTex()
  WHILE In->weGo()
    In->readTo(S)
    VAR bl = STACK_NEW : In->Tex = Ma->expand(In->Tex, bl)
    Kompri(In->Tex, 1)
    IF In->LaCh() <> ASC(!"\n") THEN EXIT WHILE
    IF LEN(In->Tex) THEN EXIT WHILE
  WEND
END SUB

' returns matching comment for '#endif'
' liefert passenden Kommentar fuer '#endif'
FUNCTION H_2_Bi.genIfComment(BYVAL Mo AS INTEGER = 0) AS STRING
  IF Op->O.MI = 0 ORELSE LEN(IfNa) = 0 THEN RETURN ""
  VAR p = INSTRREV(IfNa, CHR(1)) : IF Mo THEN RETURN " ' " & MID(IfNa, p + 1)
  VAR r = MID(IfNa, p + 1) : IfNa = LEFT(IfNa, p - 1) : RETURN " ' " & r
END FUNCTION

#DEFINE SET_CODE(_V_) Op->I.CODE = Op->I._V_ : IF Op->T._V_ = 0 THEN RETURN "" ELSE

' translates a single line
' uebersetzt einzelne Zeile
FUNCTION H_2_Bi.Line_() AS STRING
  VAR i = 0 ', Text = ""
  SELECT CASE nextWord(In->Tex, i)
  CASE "typedef" : SET_CODE(TY) i += 2 : ModI = &b0001011 : ModO = OUT_TYPE
  CASE "struct", "enum", "union", "class"
                   SET_CODE(TY) i = 1  : ModI = &b0001011 : ModO = OUT_TYPE
  CASE "static"  : SET_CODE(ST) i += 2 : ModI = &b0001011 : ModO = OUT_STATIC
  CASE "const"   : SET_CODE(CO) i += 2 : ModI = &b1001010 : ModO = OUT_CONST
  CASE "extern"  : SET_CODE(EX) i += 2 : ModI = &b0011001 : ModO = OUT_EXTERN
  CASE ELSE      : SET_CODE(DI) i = 1  : ModI = &b0001011 : ModO = OUT_DIM
  END SELECT
  Tex = LTRIM(MID(In->Tex, i), TRIMM)
  translate()
  IF Er->E.NONA ANDALSO Er->E.NOTY THEN RETURN ""
  IF Er->E.NOTY THEN
    IF ModO = OUT_TYPE THEN
      IF 0 = Op->T.UT ANDALSO STACK_FIN(Ou->TyNa, Nam) THEN _
         STACK_ADD(Ou->TyNa, Nam) : Typ = Nam & TYKENN
    ELSE
      IF Op->T.AN THEN IF LEN(Typ) THEN Typ = "ANY " & Typ ELSE Typ = "ANY PTR"
    END IF
  ELSE
    IF Op->T.UT ANDALSO _
       Typ = Nam ANDALSO _
       STACK_FIN(Ou->TyNa, Nam) = 0 THEN STACK_ADD(Ou->TyNa, Nam) : Typ = Nam & TYKENN
  END IF : RETURN genDefLine()
END FUNCTION

' generates a FB field dimension
' erzeugt eine FB Feld-Dimensionierung, wenn eingeschaltet
FUNCTION H_2_Bi.genFieldDim(BYREF Di AS STRING) AS INTEGER
  VAR i = 1, l = 0, az = 0, r = ""
  WHILE i < LEN(Di)
    l = CVI(MID(Di, i, 4))
    i += 4
    VAR t = TRIM(MID(Di, i, l), TRIMM)
    i += l
    IF LEN(t) THEN
      IF Op->O.NT THEN r &= "0 TO "
      IF t[0] >= ASC("A") THEN
        IF t[0] >= ASC("A") THEN IF Op->T.KW THEN IF checkFbKw(t) THEN t &= TYKENN
        r &= t & "-1"
      ELSE
        l = VALINT(t)
        IF l THEN
          IF Op->O.NT THEN r &= l & "-1" ELSE r &= STR(l - 1)
        ELSE
          r &= "0"
        END IF
      END IF
    ELSE
      r &= "..." : Er->E.NODI = 1 : az += 1
    END IF : r &= ", "
  WEND : Di = "(" & RTRIM(r, ", ") & ")" : RETURN az
END FUNCTION

' checks Nam for PTR, dimensions and initializers
' prueft Nam auf PTR, Dimendionierung und Initialisierung
' ModI:
' 0: allow field dimensioning
' 1: Initialisierung (= ... | : ...)
' 2: only one name (no ,)
' 3: FB keyword check
' 4: ALIAS for name
SUB H_2_Bi.checkNaTy()
  STATIC AS ZSTRING PTR con = @!"const\0"
  VAR ln = LEN(Nam) - 1, p = 0, pt = 0, pkorr = 0, l = 0, cfl = 0
  VAR n = "", di = "", zu = "", al = ""
  VAR zp = IIF(RIGHT(" " & Typ, 8) = " ZSTRING", LEN(Typ) - 6, 0)
  FOR i AS INTEGER = 0 TO 4 : NO(i) = "" : NEXT
  IF Op->T.PT THEN IF STACK_FIN(Ou->SuFu, Typ) THEN pkorr = -1
  DO
    FOR i AS INTEGER = p TO ln
      IF Nam[i] = con[l] THEN '                        check for 'const'
        l = 0
        DO : i += 1 : l += 1 : LOOP UNTIL Nam[i] <> con[l] OR i > ln
        IF l < 5 ORELSE CHAR_TYP[Nam[i]] <= 3 THEN p = i - l : EXIT FOR
        cfl = 1
      END IF
      IF CHAR_TYP[Nam[i]] <= 2 THEN p = i : EXIT FOR
      IF Nam[i] = ASC("*") THEN pt += 1
    NEXT : l = 0 : IF pt THEN pt += pkorr
    FOR i AS INTEGER = p TO ln '                               read name
      IF CHAR_TYP[Nam[i]] < 5 THEN l += 1 ELSE EXIT FOR
    NEXT : n = MID(Nam, p + 1, l) : p += l
    FOR p = p TO ln '                      read dimension & initializers
      SELECT CASE AS CONST Nam[p]
      CASE ASC("[")
        VAR e = findBlockEnd(Nam, p, ln)
        IF BIT(ModI, 0) THEN
          IF e > 1 THEN
            VAR l = e - p - 1, r = MID(Nam, p + 2, l)
            l -= 1 : genQuoteNLogic(r, 0, l, 1)
            di &= MKI(l + 1) & r
            p = e
          END IF
        ELSE
          Er->E.NODI = 1
        END IF
      CASE ASC("="), ASC(":")
        VAR e = findBlockEnd(Nam, p, ln, ASC(",")) : IF e < 0 THEN e = ln + 1
        VAR l = e - p - 1, r = TRIM(MID(Nam, p + 2, l), TRIMM)
        IF BIT(ModI, 1) ANDALSO LEN(r) THEN
          zu = " " & CHR(Nam[p]) & " " & r
          p = 3 : l = LEN(zu) - 1 : genQuoteNLogic(zu, p, l, 1)
        ELSE
          Er->E.NOIN = 1
        END IF : p = e - 1 : EXIT FOR
      CASE ASC(",") : p += 1 : EXIT FOR
      END SELECT
    NEXT

    IF LEN(n) THEN
      IF Op->T.KW ANDALSO BIT(ModI, 3) ANDALSO checkFbKw(n) THEN
        IF BIT(ModI, 4) THEN al = " ALIAS """ & n & """"
        n &= TYKENN
      ELSEIF Op->O.AL ANDALSO BIT(ModI, 4) THEN
        al = " ALIAS """ & n & """"
      END IF
    ELSE
      Er->E.NONA = 1
    END IF

    IF BIT(ModI, 2) THEN '                           paralist/SuFu modus
      IF Er->E.NODI THEN IF LEN(Typ) THEN pt += 1 : Er->E.NODI = 0
      IF zp THEN IF pt = 0 THEN Typ = LEFT(Typ, zp - 1) & "UBYTE"
      IF cfl THEN Typ &= " CONST"
      FOR i AS INTEGER = 1 TO pt : Typ &= " PTR" : NEXT
      Typ &= zu : Nam = n & al : EXIT SUB
    END IF

    VAR po = 0
    IF LEN(di) THEN '                               dimension (0 TO ...)
      po = 1
      IF genFieldDim(di) = 1 THEN
        IF zp THEN
          IF RIGHT(zu, 1) = """" THEN
            di = "" : pt += 1 : Er->E.NODI = 0
          ELSEIF LEFT(zu, 4) = " = {" THEN
            MID(di, 2, 3) = "..." : po = 3 : Er->E.NODI = 0
          END IF
        ELSE
          IF LEFT(zu, 4) = " = {" THEN MID(di, 2, 3) = "..." : Er->E.NODI = 0
        END IF
      END IF
      n &= di : di = ""
    ELSE
      IF zp THEN IF pt = 0 THEN po = 2
    END IF

    IF LEN(zu) THEN
      IF zp THEN IF INSTR(zu, ANY "'") THEN po = 2
      n &= zu : zu = ""
    END IF
    IF pt THEN
      IF LEN(NO(4)) THEN NO(4) &= !"\t"
      IF cfl THEN NO(4) &= "&"
      FOR i AS INTEGER = 1 TO pt : NO(4) &= "*" : NEXT : pt = 0
      NO(4) &= n
    ELSE
      IF LEN(NO(po)) THEN NO(po) &= ", "
      NO(po) &= n
    END IF : n = ""
  LOOP UNTIL p >= ln
END SUB

#MACRO ADD_NAMES(_NO_, _TYP_)
  IF LEN(NO(_NO_)) THEN
    IF LEN(r) THEN r &= NL
    SELECT CASE AS CONST mo
    CASE OUT_TYPE, OUT_CONST : r &= Pr(OUT_DIM) '           TYPE / CONST
    CASE ELSE : r &= Pr(mo)
    END SELECT : r &= _TYP_ & NO(_NO_)
  END IF
#ENDMACRO

' generates a new definition line
' generiert eine Definitionszeile
FUNCTION H_2_Bi.genDefLine() AS STRING
  VAR r = "", mo = ModO AND (OUT_SUB - 1)
  IF ModO >= OUT_SUB THEN '                               SUB / FUNCTION
    IF mo = OUT_Tabz THEN RETURN Pr(mo) & Nam & " AS " & Typ
    IF Op->T.PT THEN IF STACK_FIN(Ou->SuFu, Nam) = 0 THEN STACK_ADD(Ou->SuFu, Nam)
    IF mo <> OUT_DIM ANDALSO mo <> OUT_CONST THEN RETURN Pr(mo) & Nam & " AS " & Typ
    SELECT CASE AS CONST ModO - mo
    CASE  OUT_SUB : SET_CODE(DE) RETURN "DECLARE SUB " & Nam & MID(Typ, 4)
    CASE OUT_FUNC : SET_CODE(DE) RETURN "DECLARE FUNCTION " & Nam & MID(Typ, 9)
    END SELECT
    RETURN Pr(mo) & Nam & " AS " & Typ '    function pointer
  END IF
  IF LEN(NO(0)) THEN
    IF mo = OUT_TYPE ANDALSO 0 = INSTR(NO(0), ",") THEN
      r = Pr(mo) & NO(0) & " AS " & Typ
    ELSE
      r = Pr(mo) & "AS " & Typ & " " & NO(0)
    END IF
  END IF
  ADD_NAMES(1, "AS " & Typ & " ")
  IF LEN(NO(2)) THEN
    IF LEN(r) THEN r &= NL
    r &= Pr(mo) & "AS UBYTE " & NO(2)
  END IF
  ADD_NAMES(3, "AS UBYTE ")
  VAR nn = -1, p = LEN(NO(4)), l = 0, p1 = 0
  WHILE p '                                                         PTRs
    VAR n = 0, cfl = 1 : p1 += l + 1 : p = INSTR(p1, NO(4), !"\t")
    IF ASC(NO(4), p1) = ASC("#") THEN cfl = -1 : p1 += 1
    WHILE ASC(NO(4), p1) = ASC("*") : n += cfl : p1 += 1 : WEND
    l = IIF(p >= p1, p, LEN(NO(4)) + 1) - p1
    IF l THEN
      IF n = nn THEN
        r &= ", "
      ELSE
        IF LEN(r) THEN r &= NL
        r &= Pr(mo) & "AS " & Typ & " "
        IF n < 0 THEN r &= "CONST "
        FOR i AS INTEGER = 1 TO ABS(n) : r &= "PTR " : NEXT
      END IF
      r &= MID(NO(4), p1, l)
    END IF
    nn = n
  WEND : RETURN r
END FUNCTION

' checks types, replaces by definition in TYPES
' prueft types, ersetzt ggf. gemaess TYPES
SUB H_2_Bi.checkTy()
  VAR l = 0, az = 0, fl = 0
  FOR i AS INTEGER = 0 TO LEN(Typ) - 1
    SELECT CASE AS CONST Typ[i]
    CASE 0 : EXIT FOR
    CASE 1 TO 32 : IF l THEN fl = 1
    CASE ELSE
      IF fl THEN Typ[l] = ASC(" ") : l += 1 : fl = 0
      Typ[l] = Typ[i] : l += 1
    END SELECT
  NEXT : Typ = LEFT(Typ, l) & " " : l += 1
  VAR r = ""
  WHILE l
    DO
      fl = 1
      WITH Co->Typ_
        VAR a = 6, e = INSTR(.Su, CHR(2))
        WHILE e > a
          VAR ls = e - a : e += 1
          VAR x = INSTR(e, .Su, CHR(1))
          IF LEFT(Typ, ls) = MID(.Su, a, ls) THEN
            Typ = MID(Typ, ls + 1)
            VAR z = SADD(.Er) + VALINT("&H" & MID(.Su, e, x - e))
            *CAST(INTEGER PTR, z - 4) += 1
            l -= ls
            IF z[0] THEN r &= *z & " "
            fl = 0 : EXIT WHILE
          END IF : a = x + 1 : e = INSTR(a, .Su, CHR(2))
        WEND : IF l <= 0 THEN EXIT WHILE
      END WITH
    LOOP UNTIL fl
    VAR p = INSTR(Typ, " ") - 1, n = LEFT(Typ, p)
    IF Op->T.KW THEN IF checkFbKw(n) THEN n &= TYKENN
    IF p <= l THEN r &= n & " " ELSE r &= n : EXIT WHILE
    Typ = MID(Typ, p + 2) : l -= p + 1
  WEND : Typ = RTRIM(r)
  IF LEN(Typ) = 0 THEN
    Er->E.NOTY = 1
  ELSE
    IF Typ = "UNSIGNED" THEN Typ = "UINTEGER"
  END IF
END SUB

' generates name and type of a C declination (type may be a FB SUB/FUNCTION)
' wandelt C-Deklaration in Name und Typ (Typ ist ggf. FB SUB/FUNCTION)
SUB H_2_Bi.translate()
  Nam = "" : Typ = "" : Af = 0 : Kl = 0
  VAR p = -2, lt = LEN(Tex) - 1, ka = "", kz = "", a = 0, e = 0, fp = 0
  FOR i AS INTEGER = lt TO 0 STEP -1 '             search for the name
    SELECT CASE AS CONST Tex[i]
    CASE ASC("(")
      IF Af = 0 THEN Kl += 1 : p = -2 : IF Kl = 0 THEN ka &= MKI(i)
    CASE ASC(")")
      IF Af = 0 THEN
        IF Kl = 0 THEN kz &= MKI(i)
        Kl -= 1 : p = -3
      END IF
    CASE ASC("'"), ASC("""") : checkAf(Af, Tex, i) : p = -2
    CASE ASC("[") : IF Af = 0 THEN kl += 1 : p = -2
    CASE ASC("]") : IF Af = 0 THEN kl -= 1 : p = -2
    'CASE ASC("*") : IF p <  0 THEN p = i - 1
    CASE ASC("*") : p = i - 1
    CASE ASC(" ") : IF p = -1 THEN p = i - 1
    CASE ASC(","), ASC(":"), ASC("=") : p = -2
    CASE ELSE : IF p = -2 THEN IF CHAR_TYP[Tex[i]] < 3 THEN p = -1
    END SELECT
  NEXT

  SELECT CASE AS CONST LEN(ka)
  CASE 0 '                                                   declaration
    Nam = TRIM(MID(Tex, p + 2), TRIMM)
    IF p < 0 THEN p = lt
  CASE 4 '                                                  SUB/FUNCTION
    a = CVI(ka)
    e = CVI(kz)
    VAR l = a - p - 1 : IF l < 0 THEN l = e - p - 1
    Nam = TRIM(MID(Tex, p + 2, l), TRIMM)
    ModI = &b0011100
  CASE ELSE '                                     check FUNCTION pointer
    VAR x = LEN(ka) - 3
    DO
      a = CVI(MID(ka, x, 4))
      e = CVI(MID(kz, x, 4))
      Nam = TRIM(MID(Tex, a + 2, e - a - 1), TRIMM & "*")
      IF INSTR(Nam, TRIMM & "(),") THEN
        x -= 4
        Er->E.ISMA = 1
      ELSE
        p = a - 1
        a = CVI(MID(ka, x - 4, 4))
        e = CVI(MID(kz, x - 4, 4))
        IF x > 5 THEN Er->E.ISMA = 1
        FOR p = p TO 0 STEP -1
          IF CHAR_TYP[Tex[p]] < 4 THEN EXIT FOR
          IF Tex[p] = ASC("*") THEN Nam = "*" & Nam
        NEXT : fp = OUT_FUNC_PTR : EXIT DO
      END IF
    LOOP UNTIL x < 5 : ModI = IIF(fp, &b0001100, &b0011100)
  END SELECT
  Typ = LEFT(Tex, p + 1) : checkTy() : checkNaTy() : IF LEN(ka) = 0 THEN EXIT SUB

  Er->shift(SHIFT_SUFU)
  VAR na = Nam, ty = " AS ", pl = "", mo = ModO + fp
  IF INSTR(na, ANY ";*") THEN Er->E.CHNA = 1
  IF Typ = "ANY" ANDALSO LEFT(Tex, 4) = "void" ANDALSO _
    (LEN(Tex) = 4 ORELSE CHAR_TYP[Tex[4]] >= 6) THEN
    ty = "SUB"
    mo += OUT_SUB
  ELSE
    IF ModO = OUT_CONST THEN ty &= "CONST "
    ty &= Typ
    mo += OUT_FUNC
  END IF
  IF Op->O.CD THEN
    p = INSTR(na, " ")
    IF p THEN na = LEFT(na, p) & "CDECL" & MID(na, p) ELSE pl = " CDECL"
  END IF
  pl &= ParaList(a + 2, e - a - 1) : IF Er->E.PATY THEN Er->E.ISMA = 1
  Nam = na : ModO = mo
  IF ty[0] = ASC("S") THEN Typ = ty & pl ELSE Typ = "FUNCTION" & pl & ty
END SUB

#MACRO TRANS_PARA(le)
  ModI = &b0101110 : translate() : IF Op->O.BV THEN r &= "BYVAL "
  IF Er->E.NOTY THEN Typ = "???" & Typ
  IF Er->E.NONA THEN
    IF Op->O.NA = 0 THEN
      Er->E.NONA = 0
    ELSE
      IF Op->T.UV THEN r &= TYKENN & " " : Er->E.NONA = 0
    END IF
  ELSE
    IF Op->O.NA THEN r &= Nam & " "
  END IF : Er->shift(SHIFT_PARA) : r &= "AS " & Typ & le
#ENDMACRO

' generates FB parameter list from C parameter list
' generiert FB-Parameterliste aus C-Parameterliste
FUNCTION H_2_Bi.ParaList(BYVAL A AS INTEGER, BYVAL L AS INTEGER) AS STRING
  VAR t = TRIM(MID(Tex, A, L), TRIMM) : IF t = "void" THEN RETURN "()"
  VAR lt = LEN(t) - 1 : IF lt < 0 THEN RETURN "()"
  VAR r = "", le = ", "
  VAR p = 0, e = findBlockEnd(t, 0, lt, ASC(","))
  Einr &= Pr(0)
  IF Op->O.WR THEN r = " _" & NL & Einr : le &= MID(r, 2)
  WHILE e > p
    Tex = TRIM(MID(t, p + 1, e - p), TRIMM)
    TRANS_PARA(le)
    p = e + 1 : e = findBlockEnd(t, p, lt, ASC(","))
  WEND : Tex = TRIM(MID(t, p + 1), TRIMM)
  IF Tex = "..." THEN
    r &= Tex
  ELSE
    TRANS_PARA("")
  END IF : Einr = LEFT(Einr, LEN(Einr) - LEN(Pr(0)))
  Er->E.SFNA = 0 : RETURN "(" & r & ")"
END FUNCTION

' returns 1 if context of () may be a cast (or 0)
' liefert 1 wenn Zeichenkette CAST sein kann, sonst 0
FUNCTION H_2_Bi.checkCast(BYVAL Aa AS INTEGER, BYVAL Ee AS INTEGER, _
                          BYREF Lt AS INTEGER, _
                          Pa() AS STRING) AS INTEGER
  WITH *In
    VAR p = skipTrenn(.Tex, Aa + 1, Lt) : IF CHAR_TYP[.Tex[p]] > 2 THEN RETURN 0
    VAR i = 0, pt = 0
    FOR i = p + 1 TO Ee - 1
      IF CHAR_TYP[.Tex[i]] >= 5 THEN IF INSTR(!" *#\t", CHR(.Tex[i])) = 0 THEN RETURN 0
      IF .Tex[i] = ASC("*") THEN pt += 1
    NEXT : Typ = RTRIM(MID(.Tex, p + 1, Ee - p), TRIMM & "*")
    checkTy() : IF Er->E.NOTY THEN Er->E.NOTY = 0 : RETURN 0
    IF Op->T.KW THEN
      FOR i = 0 TO UBOUND(Pa) ' remove mangling on macro parameter names
        IF checkFbKw(Pa(i)) THEN STRreplace(Typ, Pa(i) & TYKENN, Pa(i))
      NEXT
    END IF
    p = skipTrenn(.Tex, Ee + 1, Lt) : IF p > Lt THEN RETURN 0
    VAR fl = INSTR("-+!~*&", CHR(.Tex[p]))
    IF fl THEN p += 1 : IF Op->T.CU = 0 THEN RETURN 0
    p = skipTrenn(.Tex, p, Lt) : IF p <= Lt THEN i = p ELSE RETURN 0
    IF fl > 4 ANDALSO CHAR_TYP[.Tex[p]] > 2 THEN RETURN 0

    VAR neu = ""
    IF CHAR_TYP[.Tex[p]] > 3 THEN
      i = INSTR("('""", CHR(.Tex[p])) :IF i = 0 THEN RETURN 0
      IF i = 3 THEN neu &= "@"
      p = findBlockEnd(.Tex, p, Lt) + 1 : IF p < 1 THEN RETURN 0
    ELSE
      WHILE CHAR_TYP[.Tex[p]] < 5 ORELSE .Tex[p] = ASC("#")
        p += 1 : IF p > Lt THEN EXIT WHILE
      WEND : VAR s = "(" : IF p > i THEN s &= "["
      i = skipTrenn(.Tex, p, Lt) : IF i > Lt THEN RETURN 0
      IF INSTR(s, CHR(.Tex[i])) THEN
        p = findBlockEnd(.Tex, i, Lt) + 1 : IF p < 1 THEN RETURN 0
      END IF
    END IF
    neu &= LTRIM(MID(.Tex, Ee + 2, p - Ee - 1)) : IF LEN(neu) = 0 THEN RETURN 0
    IF fl THEN IF Op->O.UC THEN Er->E.USCA = 1 ELSE RETURN 0
    VAR w = *IIF(CHAR_TYP[.Tex[Aa - 1]] < 5, @" ", @"") & "CAST("
    IF pt THEN
      IF Op->T.PT THEN IF STACK_FIN(Ou->SuFu, Typ) THEN pt -= 1
      FOR i = 1 TO pt : Typ &= " PTR" : NEXT
    ELSE
      IF RIGHT(" " & Typ, 8) = " ZSTRING" THEN Typ = LEFT(Typ, LEN(Typ) - 7) & "UBYTE"
    END IF
    .Tex = LEFT(.Tex, Aa) & w & Typ & ", " & neu & ")" & MID(.Tex, p + 1)
    Lt = LEN(.Tex) - 1
  END WITH : RETURN 1
END FUNCTION

' checks #define line, translates CASTs into FB source, returns start pos
' prueft #define-Zeile, wandelt CASTs in FB Quelltext, liefert Startpos
FUNCTION H_2_Bi.genCast(BYREF P AS INTEGER, BYREF Lt AS INTEGER) AS INTEGER
  VAR n = nextWord(In->Tex, P)
  IF Op->T.KW ANDALSO checkFbKw(n) THEN
    In->Tex = LEFT(In->Tex, P) & TYKENN & MID(In->Tex, P + 1)
    P += LEN(TYKENN) : Lt += LEN(TYKENN)
  END IF : IF P >= Lt THEN RETURN 0
  REDIM AS STRING pa(0)
  IF In->Tex[P] = ASC("(") THEN Ma->getParList(In->Tex, P, Lt, pa())
  IF Op->T.CS = 0 ANDALSO Op->T.CU = 0 THEN RETURN 0
  VAR a = P, e = Lt, fl = 0
  WHILE a >= P
    WHILE In->Tex[e] <> ASC(")")
      e -= 1 : IF e < P THEN RETURN fl
    WEND
    a = findBlockEnd(In->Tex, e, P) : IF a < P THEN RETURN fl
    IF checkCast(a, e, Lt, pa()) THEN fl += 1 : e = a - 1 ELSE e -= 1
  WEND : RETURN fl
END FUNCTION

#DEFINE AddOp(v1,f1) fl = f1 : r &= *IIF(RIGHT(r, 1) <> "=", @" ", @"") & v1

' checks T for C logic, replaces by FB commands and numbers
' prueft T auf C-LogiK-Befehle, ersetzt sie durch FB-Befehle bzw. Zahlen
FUNCTION H_2_Bi.genLogic(BYREF T AS STRING, BYVAL Mo AS INTEGER = 0) AS STRING
  IF Op->T.LO = 0 THEN RETURN T
  VAR fl = 0, lt = LEN(T) - 1 : IF lt <= 0 THEN RETURN T
  DIM AS STRING r, _or, _and, _not
  IF Mo THEN _or = "ORELSE" : _and = "ANDALSO" : _not = "0 = " _
        ELSE _or = "OR" : _and = "AND" : _not = "NOT "
  FOR i AS INTEGER = 0 TO lt
    SELECT CASE AS CONST fl
    CASE 2 '                                                      indent
      SELECT CASE AS CONST T[i]
      CASE ASC(!"\t"), ASC(" ") : r &= " "
      CASE ELSE : fl = 0
      END SELECT
    CASE 3 '                                                     decimal
      SELECT CASE AS CONST T[i]
      CASE ASC("0") TO ASC("9") : r &= CHR(T[i])
      CASE ASC("."), ASC("E"), ASC("e") : r &= CHR(T[i])
      CASE ASC("-"), ASC("+") : r &= CHR(T[i])
      CASE ELSE : fl = 0
      END SELECT
    CASE 4 '                                                 hexadecimal
      SELECT CASE AS CONST T[i]
      CASE ASC("0") TO ASC("9") : r &= CHR(T[i])
      CASE ASC("a") TO ASC("f") : r &= UCASE(CHR(T[i]))
      CASE ASC("A") TO ASC("F") : r &= CHR(T[i])
      CASE ELSE : fl = 0
      END SELECT
    CASE 5 '                                                       octal
      SELECT CASE AS CONST T[i]
      CASE ASC("0") TO ASC("7") : r &= CHR(T[i])
      CASE ELSE : fl = 0
      END SELECT
    CASE 6 '                                                leading zero
      SELECT CASE AS CONST T[i]
      CASE ASC("0") TO ASC("7") : r &= "&o" & CHR(T[i]) : fl = 5
      CASE ASC("8"), ASC("9"), ASC(".") : r &= "0" & CHR(T[i]) : fl = 3
      CASE ASC("x"), ASC("X") : r &= "&h" : fl = 4
      CASE ELSE : r &= "0" : fl = 0
      END SELECT
    CASE 32 : IF T[i] > ASC(" ") THEN r &= " " : fl = 0
    CASE ASC("!")
      SELECT CASE AS CONST T[i]
      CASE ASC("=") : AddOp("<>", 1)
      CASE ELSE : AddOp(_not, 0)
      END SELECT
    CASE ASC("-") : fl = 0 : IF T[i] = ASC(">") THEN r &="->" : i += 1 ELSE r &= "-"
    CASE ASC(">") ': IF T[i] = ASC(">") THEN AddOp("SHR", 32) ELSE AddOp(">", 0)
      SELECT CASE AS CONST T[i]
      CASE ASC(">") : AddOp("SHR", 32)
      CASE ASC("=") : AddOp(">=", 1)
      CASE ELSE : AddOp(">", 0)
      END SELECT
    CASE ASC("<") ': IF T[i] = ASC("<") THEN AddOp("SHL", 32) ELSE AddOp("<", 0)
      SELECT CASE AS CONST T[i]
      CASE ASC("<") : AddOp("SHL", 32)
      CASE ASC("=") : AddOp("<=", 1)
      CASE ELSE : AddOp("<", 0)
      END SELECT
    CASE ASC("|")
      SELECT CASE AS CONST T[i]
      CASE ASC("0") : AddOp(_or, 6)
      CASE ASC("|") : AddOp(_or, 32)
      CASE ASC("=") : AddOp("OR=", 1)
      CASE ELSE : AddOp("OR", 0)
      END SELECT
    CASE ASC("&")
      SELECT CASE AS CONST T[i]
      CASE ASC("&") : AddOp(_and, 32)
      CASE ASC("=") : AddOp("AND=", 1)
      CASE ELSE
        IF CHAR_TYP[T[i]] <= 2 ORELSE T[i] = ASC("(") THEN
          r &= "@" : fl = 0
        ELSE
          AddOp("AND", 0)
        END IF
      END SELECT
    CASE ASC("=") : AddOp("=", IIF(T[i] = ASC("="), 1, 0))
    CASE ELSE : fl = 0
    END SELECT

    IF fl = 0 THEN
      SELECT CASE AS CONST T[i]
      CASE ASC(!"\n")
        fl = LEN(r) : IF fl THEN fl -= 1 : IF r[fl] = ASC("\") THEN r[fl] = ASC("_")
        r &= CHR(T[i]) : fl = 2
      CASE ASC("0") : fl = 6
      CASE ASC("1") TO ASC("9") : r &= CHR(T[i]) : fl = 3
      CASE ASC(!"\t"), ASC(" ") : fl = 32
      CASE ASC("^") : AddOp("XOR", 32)
      CASE ASC("~") : AddOp("NOT", 32)
      CASE ASC("%") : AddOp("MOD", 32)
      CASE ASC("!") : fl = T[i]
      CASE ASC(">") : fl = T[i]
      CASE ASC("<") : fl = T[i]
      CASE ASC("|") : fl = T[i]
      CASE ASC("&") : fl = T[i]
      CASE ASC("=") : fl = T[i]
      CASE ASC("-") : fl = T[i]
      CASE ELSE : r &= CHR(T[i])
      END SELECT
    END IF
  NEXT : IF fl > 5 THEN r &= CHR(IIF(fl = 6, ASC("0"), fl))
  STRreplace(r, "defined", "DEFINED")
  STRreplace(r, "sizeof", "SIZEOF") : RETURN r
END FUNCTION

' translates 'x' into ASC("x"), '? :' to IIF, places ! before "
' wandelt 'x' in ASC("x"), ergaenzt ! vor ", wandelt '? :' in IIF
SUB H_2_Bi.genQuoteNLogic(BYREF T AS STRING, BYVAL Aa AS INTEGER, _
                          BYREF Lt AS INTEGER, BYVAL Mo AS INTEGER = 0)

  VAR e = Aa, y = "", z = "", r = T
  T = LEFT(T, Aa)
  FOR i AS INTEGER = Aa TO Lt
    IF CHAR_TYP[r[i]] = 8 THEN
      T &= genLogic(MID(r, e + 1, i - e), Mo)
      IF Op->T.QU THEN
        y = "@!""" : z = """"
        IF r[i] = ASC("'") THEN y = "ASC(" & MID(y, 2) : z &= ")"
        IF RIGHT(T, 2) = " L" THEN y = "WSTR(" & MID(y, 2) : z &= ")" : T = LEFT(T, LEN(T) - 1)
      ELSE
        y = CHR(r[i]) : z = y
      END IF
      e = findBlockEnd(r, i, Lt) : IF e < 0 THEN T &= y : e = i + 1 : EXIT FOR
      IF y[1] = ASC("S") THEN IF r[i + 1] = ASC("""") THEN y &= "\"
      T &= y & MID(r, i + 2, e - i - 1) & z
      i = e : e += 1
    END IF
  NEXT : T &= genLogic(MID(r, e + 1), Mo) : Lt = LEN(T) - 1
  IF Op->T.II = 0 THEN EXIT SUB '                     no IIF translation
  VAR i = Lt + 1 : Af = 0
  DO
    e = -1
    DO
      i -= 1 : IF i < Aa THEN EXIT DO, DO
      SELECT CASE AS CONST T[i]
      CASE ASC("'"), ASC("""") : checkAf(Af, T, i)
      CASE ASC(")"), ASC("]"), ASC(",") : IF Af = 0 THEN e = i
      CASE ASC(":") : IF Af = 0 THEN EXIT DO
      END SELECT
    LOOP
    VAR a = 0, p = findBlockEnd(T, i - 1, Aa, ASC("?")) : IF p < 0 THEN EXIT DO
    IF e = -1 THEN '                                     complete STRING
      T[i] = ASC(",") : T[p] = ASC(",")
      T = LEFT(T, Aa) & "IIF(" & MID(T, Aa + 1) & ")" : EXIT DO
    END IF

    SELECT CASE T[e]
    CASE ASC(")")
      a = findBlockEnd(T, i - 1, Aa, ASC("(")) : IF a < 0 THEN EXIT DO
    CASE ASC("]")
      a = findBlockEnd(T, i - 1, Aa, ASC("[")) : IF a < 0 THEN EXIT DO
    CASE ELSE
      a = findBlockEnd(T, i - 1, Aa, ASC(","))
      IF a < 0 THEN a = findBlockEnd(T, i - 1, Aa, ASC("("))
      IF a < 0 THEN a = Aa
    END SELECT
    T[i] = ASC(",")
    T[p] = ASC(",")
    IF T[e] = ASC(")") THEN
      T = LEFT(T, a) & "IIF" & MID(T, a + 1) : i += 3
    ELSE
      T = LEFT(T, a + 1) & "IIF(" & MID(T, a + 2, e - a - 1) & ")" & MID(T, e + 1)
      i += 4
    END IF
  LOOP : Lt = LEN(T) - 1
END SUB

' checks if a define line is unsave
' prueft ob eine define Zeile unsicher ist
FUNCTION H_2_Bi.UnsaveDefine() AS INTEGER
  Af = 0
  FOR i AS INTEGER = 0 TO LEN(In->Tex) - 1
    SELECT CASE AS CONST CHAR_TYP[In->Tex[i]]
    CASE 8 : checkAf(Af, In->Tex, i)
    CASE 12 : IF Af = 0 THEN Er->E.USDE = 1 : RETURN -1
    END SELECT
  NEXT : RETURN 0
END FUNCTION

' reads one (or multiple) line starting with '#'
' liest eine oder mehrere Zeilen fuer den Praeprozessor
FUNCTION H_2_Bi.PreCo() AS STRING
  In->readLine(1) : Kompri(In->Tex, -1)
  VAR a = 0
  SELECT CASE nextWord(In->Tex, a)
  CASE "include" : SET_CODE(PI) VAR l = LEN(In->Tex) - 1
    a = findBlockEnd(In->Tex, l, 0) : IF a < 0 THEN RETURN genKom("#" & In->Tex)
    VAR fn = MID(In->Tex, a + 2, l - a - 1)
    IF Op->O.SI THEN IF Act(fn) THEN RETURN Tex ELSE RETURN ""
    VAR er = Ou->checkFileNam(fn) : IF LEN(er) THEN RETURN er
    fn = MID(In->Tex, a + 2, l - a - 1)
    RETURN "#INCLUDE ONCE """ & LEFT(fn, INSTRREV(fn, ".")) & "bi"""
  CASE "ifdef"  : SET_CODE(PX)
    IF Op->O.MI THEN IfNa &= CHR(1) & TRIM(MID(In->Tex, a + 2), TRIMM)
    MID(In->Tex, a - 4, 5) = "IFDEF"
  CASE "ifndef" : SET_CODE(PX)
    IF Op->O.MI THEN IfNa &= CHR(1) & TRIM(MID(In->Tex, a + 2), TRIMM)
    MID(In->Tex, a - 5, 6) = "IFNDEF"
  CASE "if"     : SET_CODE(PX) genQuoteNLogic(In->Tex, a, LEN(In->Tex) - 1)
    IF Op->O.MI THEN
      VAR t = CHR(1) & LTRIM(MID(In->Tex, a + 2), TRIMM)
      IF LEN(t) > 16 THEN IfNa &= LEFT(t, 16) & "..." ELSE IfNa &= t
    END IF : MID(In->Tex, a - 1, 2) = "IF"
  CASE "elif"   : SET_CODE(PX) genQuoteNLogic(In->Tex, a, LEN(In->Tex) - 1)
    In->Tex = "ELSEIF" & MID(In->Tex, a + 1)
  CASE "else"   : SET_CODE(PX) MID(In->Tex, a - 3, 4) = "ELSE"
    In->Tex &= genIfComment(1)
  CASE "endif"  : SET_CODE(PX) MID(In->Tex, a - 4, 5) = "ENDIF"
    In->Tex &= genIfComment()
  CASE "error"  : SET_CODE(PE) MID(In->Tex, a - 4, 5) = "ERROR"
  CASE "undef"  : SET_CODE(PU) MID(In->Tex, a - 4, 5) = "UNDEF"
  CASE "define" : SET_CODE(PD) MID(In->Tex, a - 5, 6) = "DEFINE"
    VAR lt = LEN(In->Tex) - 1
    IF a >= lt THEN Er->E.NOMN = 1 : RETURN genKom("#" & In->Tex)
    IF genCast(a, lt) THEN Op->I.CODE OR= Op->I.CA
    IF In->Tex[a] = ASC(" ") THEN a += 1
    genQuoteNLogic(In->Tex, a, lt, 1)
    IF UnsaveDefine() THEN IF Op->O.UD THEN RETURN genKom("#" & In->Tex)
  CASE ELSE : RETURN genKom("#" & In->Tex)
  END SELECT : RETURN "#" & In->Tex
END FUNCTION

#MACRO OP_I_BLCO(_N_, _M_)
  IF Op->I.BLCO THEN
    c = In->readCCom(BloCom OR _M_) : IF LEN(c) THEN r &= _N_ & ">" & c & "<"
  END IF
#ENDMACRO

' generating FB lines for ENUM block
' erzeugt FB-Zeilen eines ENUM-Blockes
FUNCTION H_2_Bi.BlockENUM() AS STRING
  VAR c = "", r = "" : Typ = "" : BlAZ = 0
  'OP_I_BLCO("", &b10)
  WHILE In->weGo()
    OP_I_BLCO("", &b10)
    read2(",}#", 1)
    OP_I_BLCO(NL & "(2)", &b10000)
    SELECT CASE AS CONST In->LaCh()
    CASE ASC("#")
      'OP_I_BLCO(NL & "A", 0)
      r &= NL & PreCo() & Er->show()
    CASE ASC(","), ASC("}"), 10, 0
      IF LEN(In->Tex) THEN
        Nam = In->Tex : ModI = &b0001010 : checkNaTy()
        r &= NL & Pr(OUT_Tabz)
        IF Er->FLE ANDALSO Op->I.ER THEN r &= genKom(Nam) & NL & Pr(OUT_Tabz)
        r &= NO(0) & Er->show() : BlAZ += 1
      END IF
      IF In->LaCh() = ASC("}") ORELSE In->LaCh() = 0 THEN EXIT WHILE
    CASE ELSE
      r &= NL & "' " & In->Tex & " unknown context ???"
      'EXIT WHILE
    END SELECT
  WEND : OP_I_BLCO("", &b0)
  RETURN r
END FUNCTION

' generates FB lines for blocks
' erzeugt FB-Zeilen fuer einen Block (TYPE/UNION)
FUNCTION H_2_Bi.BlockTyUn() AS STRING
  VAR c = "", r = "" : BlAZ = 0
  OP_I_BLCO("", &b10)
  WHILE In->weGo()
    OP_I_BLCO("", &b10)
    read2(";={}#", 1)
    OP_I_BLCO(NL, &b10000)
    SELECT CASE AS CONST In->LaCh()
    CASE ASC("#")
      r &= NL & PreCo() & Er->show()
    CASE ASC(";"), ASC("=")
      IF In->LaCh() = ASC("=") THEN In->Tex &= "=" : read2(";}") ' !!! #-PreCo Zeilen
      IF LEN(In->Tex) = 0 THEN CONTINUE WHILE
      IF Op->I.BLCO = 0 THEN
        IF Er->FLE ANDALSO Op->I.ER THEN r &= NL & genKom(In->Tex)
      END IF : ModI = &b0000011 : ModO = OUT_Tabz : Tex = In->Tex : translate()
      r &= NL & genDefLine() & Er->show() : BlAZ += 1
    CASE ASC("{")
      IF Op->I.BLCO THEN r &= NL & genKom(In->Tex) & "{"
      VAR neu = Block()
      IF Op->I.BLCO THEN IF LEN(In->Tex) THEN r &= "} " & In->Tex & ";" ELSE r &= "};"
      r &= NL
      VAR p = INSTR(neu, "AS "), l = LEN(r) ' remember position of nested block names
      WHILE p
        BlRp = MKI(l + p + 3) & BlRp : p = INSTR(p + 1, neu, "AS ")
      WEND : r &= neu & Er->show() : BlAZ += 1
    CASE ELSE
      IF In->LaCh() <> ASC("}") THEN r &= NL & "' " & In->Tex & " unknown termination ???"
      EXIT WHILE
    END SELECT
  WEND : OP_I_BLCO("", &b0)
  RETURN r
END FUNCTION

' checks names of blocks
' prueft Namen eines Blockes, liefert ggf auch TYPE-Zeile in Nam
SUB H_2_Bi.BlockName(BYVAL Mo AS INTEGER)
  IF LEN(Typ) THEN '                                         block Typ {
    IF LCASE(Typ) = LCASE(Nam) THEN Nam = ""
    IF Mo < 2 THEN IF Op->T.KW THEN IF checkFbKw(Typ) THEN Typ &= TYKENN
    IF 0 = LEN(Nam) THEN EXIT SUB '                     block Typ {...};
    IF Typ = nextword(Nam) THEN Nam = LTRIM(MID(Nam, LEN(Typ) + 1), ANY " ,")
  ELSEIF 0 = LEN(Nam) THEN '                                block {...};
    IF Mo THEN IF Op->T.UV THEN Typ = TYKENN
    EXIT SUB
  ELSE '                                                block {...} Nam;
    Typ = nextWord(Nam)
    Nam = LTRIM(MID(Nam, LEN(Typ) + 1), ANY " ,")
  END IF '                       block {...} Nam; | block Typ {...} Nam;
  IF 0 = LEN(Nam) THEN EXIT SUB
  ModI = IIF(Mo, IIF(Mo > 1, &b0000011, &b0001011), &b0001001) : checkNaTy()
  ModO = OUT_TYPE : Nam = genDefLine()
END SUB

' generates one (or more) block(s)
' erzeugt einen (bei Verschachtelung mehrere) Blo(e)ck(e)
FUNCTION H_2_Bi.Block(BYVAL A AS INTEGER = 0) AS STRING
  DIM AS STRING neu, blna, ei = Einr, rp = BlRp, art
  VAR fl = 0, i = A, rr = ""
  Typ = nextWord(In->Tex, i)
  SELECT CASE Typ
  CASE "enum"   : art = "ENUM"  : fl = 0 : Op->I.CODE = Op->I.BE
  CASE "union"  : art = "UNION" : fl = 1 : Op->I.CODE = Op->I.BU
  CASE "struct", "class" : art = "TYPE"  : fl = 1 : Op->I.CODE = Op->I.BT
  CASE ELSE
    SELECT CASE Typ
    CASE "extern", "namespace" : Nam = "line"
    CASE ELSE : Nam = "block"
      IF In->LaCh() <> ASC("}") THEN In->readTo("}")
    END SELECT : Op->I.CODE = Op->I.UT : IF Op->O.MB = 0 THEN RETURN ""
    IF LEN(Typ) THEN BlTy &= CHR(1) & Typ : RETURN "' removed """ & Typ & """ " & Nam
    VAR p = INSTRREV(BlTy, CHR(1))
    IF p THEN Typ = MID(BlTy, p + 1) : BlTy = LEFT(BlTy, p - 1) ELSE Typ = "???"
    RETURN "' } from removed """ & Typ & """ " & Nam
  END SELECT '                                       enum, struct, union
  blna = nextWord(In->Tex, i)
  IF BlNr = 0 THEN BlVo = "" : BlXx = "" : Einr = Pr(0) : In->newBlock()
  BlNr += 1
  IF fl THEN BlRp = "" : neu = BlockTyUn() ELSE neu = BlockENUM()
  BlNr -= 1
  read2(";", 1) : Nam = In->Tex : Typ = blna
  BlockName(BlNr + fl) : Einr = ei
  BlVo &= rr
  IF LEN(Typ) THEN IF Op->T.UT THEN IF STACK_FIN(Ou->TyNa, Typ) THEN Typ &= TYKENN

  IF fl THEN '                 remember positions for names (TYPE/UNION)
    i = LEN(BlVo) : fl = LEN(BlRp) - 3
    IF fl > 0 THEN BlRp &= MKI(LEN(art) + LEN(Typ) + 1) : fl += 4
    IF fl < 5 THEN
      BlXx &= MKI(i + LEN(art) + 2)
    ELSE
      VAR o = CVI(MID(BlRp, fl, 4)) + i
      FOR j AS INTEGER = 1 TO fl - 4 STEP 4
        BlXx &= MKI(o + CVI(MID(BlRp, j, 4)))
      NEXT : BlXx &= MKI(i + LEN(art) + 2)
    END IF : BlRp = rp
  END IF

  IF BlAZ THEN
    BlVo &= art & " " & Typ & neu & NL & "END " & art
  ELSE
    IF LEN(Typ) = 0 THEN RETURN ""
    art = "t" : BlVo &= "TYPE " & Typ & " AS ANY PTR"
  END IF

  IF BlNr THEN '                                            nested block
    BlVo &= NL & NL : IF LEN(Nam) THEN RETURN Nam
    RETURN Pr(0) & "AS " & Typ & " " & Typ '          gets mangled later
  END IF
  IF LEN(Nam) THEN STRReplace(Nam, Pr(0) & "AS", "TYPE AS") : Nam = NL & NL & Nam
  SELECT CASE AS CONST art[0]
  CASE ASC("T") : SET_CODE(BT)
  CASE ASC("E") : SET_CODE(BE)
  CASE ASC("U") : SET_CODE(BU)
  CASE ASC("t") : SET_CODE(TY)
  END SELECT : fl = LEN(BlXx) - 4
  IF fl > 0 THEN '                                    mangle block names
    VAR po = 0, x = LEN(BlVo)
    DO
      i = 0
      FOR j AS INTEGER = 1 TO fl STEP 4
        po = CVI(MID(BlXx, j, 4))
        IF po < x THEN IF po > i THEN i = po
      NEXT : IF i = 0 THEN EXIT DO
      x = i : BlVo = LEFT(BlVo, i - 1) & Typ & "_" & MID(BlVo, i)
    LOOP
  END IF : Ou->LaWo = CHR(1) : RETURN BlVo & Nam
END FUNCTION
